JBoss API: Class Scheduler

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.util
Class Scheduler

    java.lang.Object
      |
      +--javax.management.NotificationBroadcasterSupport
            |
            +--org.jboss.util.ServiceMBeanSupport
                  |
                  +--org.jboss.util.Scheduler

All Implemented Interfaces:
  javax.management.MBeanRegistration, javax.management.NotificationBroadcaster, SchedulerMBean, Service, ServiceMBean

public class Scheduler
extends ServiceMBeanSupport
implements SchedulerMBean

Scheduler Instance to allow clients to run this as a scheduling service for any Schedulable instances.
ATTENTION: The scheduler instance only allows to run one schedule at a time. Therefore when you want to run two schedules create to instances with this MBean. Suggested Object Name for the MBean are:
jboss:service=Scheduler,schedule=
This way you should not run into a name conflict.

Author:
  Andreas Schaefer, Cameron (camtabor)

  Revisions:

  20010814 Cameron:

  - Checks if the TimerMBean is already loaded
  - Created a SchedulerNotificationFilter so that each Scheduler only get its notifications
  - Stop was broken because removeNotification( Integer ) was broken

  20011026 Andy:

  - Move the SchedulerNotificationFilter to become an internal class and renamed to NotificationFilter
  - MBean is not bind/unbind to JNDI server anymore

  20020117 Andy:

  - Change the behaviour when the Start Date is in the past. Now the Scheduler will behave as the Schedule is never stopped and find the next available time to start with respect to the settings. Therefore you can restart JBoss without adjust your Schedule every time. BUT you will still loose the calls during the Schedule was down.
  - Added parsing capabilities to setInitialStartDate. Now NOW: current time, and a string in a format the SimpleDataFormat understand in your environment (US: m/d/yy h:m a) but of course the time in ms since 1/1/1970.
  - Some fixes like the stopping a Schedule even if it already stopped etc.

  20020118 Andy:

  - Added the ability to call another MBean instead of an instance of the given Schedulable class. Use setSchedulableMBean() to specify the JMX Object Name pointing to the given MBean. Then if the MBean does not contain the same method as the Schedulable instance you have to specify the method with setSchedulableMBeanMethod(). There you can use some constants.

  20020119 Andy:

  - Added a helper method isActive()
  - Fixed a bug not indicating that no MBean is used when setSchedulableClass() is called.
  - Fixed a bug therefore that when NOW is set as initial start date a restart of the Schedule will reset the start date to the current date
  - Fixed a bug because the start date was update during recalculation of the start date when the original start date is in the past (see above). With this you could restart the schedule even after all hits were fired when the schedule was not started immediately after the initial start date was set.

Inner Class Summary
`class` | `Scheduler.Listener`
`class` | `Scheduler.MBeanListener`
`static class` | `Scheduler.SchedulableExample` A test class for a Schedulable Class

Field Summary
`static java.lang.String` | `JMX_NAME`
`static java.lang.String` | `JNDI_NAME`

Fields inherited from class org.jboss.util.ServiceMBeanSupport
`log, server`

Fields inherited from interface org.jboss.util.SchedulerMBean
`OBJECT_NAME`

Fields inherited from interface org.jboss.util.ServiceMBean
`STARTED, STARTING, states, STOPPED, STOPPING`

Constructor Summary
`Scheduler()` Default (no-args) Constructor
`Scheduler(java.lang.String pSchedulableClass, java.lang.String pInitArguments, java.lang.String pInitTypes, java.lang.String pInitialStartDate, long pSchedulePeriod, long pNumberOfRepetitions)` Constructor with the necessary attributes to be set

Method Summary
`long` | `getInitialRepetitions()`
`java.lang.String` | `getInitialStartDate()`
`java.lang.String` | `getName()`
`javax.management.ObjectName` | `getObjectName(javax.management.MBeanServer pServer, javax.management.ObjectName pName)`
`long` | `getRemainingRepetitions()`
`java.lang.String` | `getSchedulableArguments()`
`java.lang.String` | `getSchedulableArgumentTypes()`
`java.lang.String` | `getSchedulableClass()`
`java.lang.String` | `getSchedulableMBean()`
`java.lang.String` | `getSchedulableMBeanMethod()`
`long` | `getSchedulePeriod()`
`javax.management.ObjectName` | `getServiceName()`
`boolean` | `isActive()`
`boolean` | `isRestartPending()`
`boolean` | `isStartAtStartup()`
`boolean` | `isStarted()`
`boolean` | `isUsingMBean()`
`void` | `restartSchedule()` Stops the server right now and starts it right now.
`void` | `setInitialRepetitions(long pNumberOfCalls)` Sets the initial number of scheduled calls.
`void` | `setInitialStartDate(java.lang.String pStartDate)` Sets the first scheduled call.
`void` | `setSchedulableArguments(java.lang.String pArgumentList)` Sets the comma seperated list of arguments for the Schedulable class.
`void` | `setSchedulableArgumentTypes(java.lang.String pTypeList)` Sets the comma seperated list of argument types for the Schedulable class.
`void` | `setSchedulableClass(java.lang.String pSchedulableClass)` Sets the fully qualified Class name of the Schedulable Class being called by the Scheduler.
`void` | `setSchedulableMBean(java.lang.String pSchedulableMBean)` Sets the fully qualified JMX MBean name of the Schedulable MBean to be called.
`void` | `setSchedulableMBeanMethod(java.lang.String pSchedulableMBeanMethod)` Sets the method name to be called on the Schedulable MBean.
`void` | `setSchedulePeriod(long pPeriod)` Sets the Schedule Period between two scheduled call.
`void` | `setStartAtStartup(boolean pStartAtStartup)` Set the scheduler to start when MBean started or not.
`void` | `startSchedule()` Starts the schedule if the schedule is stopped otherwise nothing will happen.
`protected void` | `startService()`
`void` | `stopSchedule(boolean pDoItNow)` Stops the schedule because it is either not used anymore or to restart it with new values.
`protected void` | `stopService()`

Methods inherited from class org.jboss.util.ServiceMBeanSupport
`destroy, destroyService, getServer, getState, getStateString, init, initService, nextSequenceNumber, postDeregister, postRegister, preDeregister, preRegister, start, stop`

Methods inherited from class javax.management.NotificationBroadcasterSupport
`addNotificationListener, getNotificationInfo, removeNotificationListener, sendNotification`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.jboss.util.ServiceMBean
`getState, getStateString`

Methods inherited from interface org.jboss.util.Service
`destroy, init, start, stop`

Field Detail

### JNDI_NAME

    public static java.lang.String JNDI_NAME

### JMX_NAME

    public static java.lang.String JMX_NAME

Constructor Detail

### Scheduler

    public Scheduler()

  Default (no-args) Constructor

### Scheduler

    public Scheduler(java.lang.String pSchedulableClass,
                     java.lang.String pInitArguments,
                     java.lang.String pInitTypes,
                     java.lang.String pInitialStartDate,
                     long pSchedulePeriod,
                     long pNumberOfRepetitions)

  Constructor with the necessary attributes to be set
  Parameters:
    `pName` - Name of the MBean

Method Detail

### startSchedule

    public void startSchedule()

  Description copied from interface: `SchedulerMBean`
  Starts the schedule if the schedule is stopped otherwise nothing will happen. The Schedule is immediately set to started even the first call is in the future.
  Specified by:
    `startSchedule` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Throws:
    `java.security.InvalidParameterException` - If any of the necessary values are not set or invalid (especially for the Schedulable class attributes).

### stopSchedule

    public void stopSchedule(boolean pDoItNow)

  Description copied from interface: `SchedulerMBean`
  Stops the schedule because it is either not used anymore or to restart it with new values.
  Specified by:
    `stopSchedule` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pDoItNow` - If true the schedule will be stopped without waiting for the next scheduled call otherwise the next call will be performed before the schedule is stopped.

### restartSchedule

    public void restartSchedule()

  Description copied from interface: `SchedulerMBean`
  Stops the server right now and starts it right now.
  Specified by:
    `restartSchedule` in interface `SchedulerMBean`

### getSchedulableClass

    public java.lang.String getSchedulableClass()

  Specified by:
    `getSchedulableClass` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Full qualified Class name of the schedulable class called by the schedule or null if not set.

### setSchedulableClass

    public void setSchedulableClass(java.lang.String pSchedulableClass)
                             throws java.security.InvalidParameterException

  Description copied from interface: `SchedulerMBean`
  Sets the fully qualified Class name of the Schedulable Class being called by the Scheduler. Must be set before the Schedule is started. Please also set the `SchedulerMBean.setSchedulableArguments(java.lang.String)` and `SchedulerMBean.setSchedulableArgumentTypes(java.lang.String)`.
  Specified by:
    `setSchedulableClass` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pSchedulableClass` - Fully Qualified Schedulable Class.
  Throws:
    `java.security.InvalidParameterException` - If the given value is not a valid class or cannot be loaded by the Scheduler or is not of instance Schedulable.

### getSchedulableArguments

    public java.lang.String getSchedulableArguments()

  Specified by:
    `getSchedulableArguments` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Comma seperated list of Constructor Arguments used to instantiate the Schedulable class instance. Right now only basic data types, String and Classes with a Constructor with a String as only argument are supported.

### setSchedulableArguments

    public void setSchedulableArguments(java.lang.String pArgumentList)

  Description copied from interface: `SchedulerMBean`
  Sets the comma seperated list of arguments for the Schedulable class. Note that this list must have as many elements as the Schedulable Argument Type list otherwise the start of the Scheduler will fail. Right now only basic data types, String and Classes with a Constructor with a String as only argument are supported.
  Specified by:
    `setSchedulableArguments` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pArgumentList` - List of arguments used to create the Schedulable intance. If the list is null or empty then the no-args constructor is used.

### getSchedulableArgumentTypes

    public java.lang.String getSchedulableArgumentTypes()

  Specified by:
    `getSchedulableArgumentTypes` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    A comma seperated list of Argument Types which should match the list of arguments.

### setSchedulableArgumentTypes

    public void setSchedulableArgumentTypes(java.lang.String pTypeList)
                                     throws java.security.InvalidParameterException

  Description copied from interface: `SchedulerMBean`
  Sets the comma seperated list of argument types for the Schedulable class. This will be used to find the right constructor and to created the right instances to call the constructor with. This list must have as many elements as the Schedulable Arguments list otherwise the start of the Scheduler will fail. Right now only basic data types, String and Classes with a Constructor with a String as only argument are supported.
  Specified by:
    `setSchedulableArgumentTypes` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pTypeList` - List of arguments used to create the Schedulable intance. If the list is null or empty then the no-args constructor is used.
  Throws:
    `java.security.InvalidParameterException` - If the given list contains a unknow datat type.

### getSchedulableMBean

    public java.lang.String getSchedulableMBean()

  Specified by:
    `getSchedulableMBean` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Object Name if a Schedulalbe MBean is set

### setSchedulableMBean

    public void setSchedulableMBean(java.lang.String pSchedulableMBean)
                             throws java.security.InvalidParameterException

  Description copied from interface: `SchedulerMBean`
  Sets the fully qualified JMX MBean name of the Schedulable MBean to be called. Attention: if set the all values set by `SchedulerMBean.setSchedulableClass(java.lang.String)`, `SchedulerMBean.setSchedulableArguments(java.lang.String)` and `SchedulerMBean.setSchedulableArgumentTypes(java.lang.String)` are cleared and not used anymore. Therefore only use either Schedulable Class or Schedulable MBean. If `SchedulerMBean.setSchedulableMBeanMethod(java.lang.String)` is not set then the schedule method as in the `Schedulable.perform(java.util.Date, long)` will be called with the same arguments. Also note that the Object Name will not be checked if the MBean is available. If the MBean is not available it will not be called but the remaining repetitions will be decreased.
  Specified by:
    `setSchedulableMBean` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pSchedulableMBean` - JMX MBean Object Name which should be called.
  Throws:
    `java.security.InvalidParameterException` - If the given value is an valid Object Name.

### getSchedulableMBeanMethod

    public java.lang.String getSchedulableMBeanMethod()

  Specified by:
    `getSchedulableMBeanMethod` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Schedulable MBean Method description if set

### setSchedulableMBeanMethod

    public void setSchedulableMBeanMethod(java.lang.String pSchedulableMBeanMethod)
                                   throws java.security.InvalidParameterException

  Description copied from interface: `SchedulerMBean`
  Sets the method name to be called on the Schedulable MBean. It can optionally be followed by an opening bracket, list of attributes (see below) and a closing bracket. The list of attributes can contain:
  - NOTIFICATION which will be replaced by the timers notification instance (javax.management.Notification)
  - DATE which will be replaced by the date of the notification call (java.util.Date)
  - REPETITIONS which will be replaced by the number of remaining repetitions (long)
  - SCHEDULER_NAME which will be replaced by the Object Name of the Scheduler (javax.management.ObjectName)
  - any full qualified Class name which the Scheduler will be set a "null" value for it
  An example could be: "doSomething( NOTIFICATION, REPETITIONS, java.lang.String )" where the Scheduler will pass the timer's notification instance, the remaining repetitions as int and a null to the MBean's doSomething() method which must have the following signature: doSomething( javax.management.Notification, long, java.lang.String ).
  Specified by:
    `setSchedulableMBeanMethod` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pSchedulableMBeanMethod` - Name of the method to be called optional followed by method arguments (see above).
  Throws:
    `java.security.InvalidParameterException` - If the given value is not of the right format

### isUsingMBean

    public boolean isUsingMBean()

  Specified by:
    `isUsingMBean` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    True if the Scheduler uses a Schedulable MBean, false if it uses a Schedulable class

### getSchedulePeriod

    public long getSchedulePeriod()

  Specified by:
    `getSchedulePeriod` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Schedule Period between two scheduled calls in Milliseconds. It will always be bigger than 0 except it returns -1 then the schedule is stopped.

### setSchedulePeriod

    public void setSchedulePeriod(long pPeriod)

  Description copied from interface: `SchedulerMBean`
  Sets the Schedule Period between two scheduled call.
  Specified by:
    `setSchedulePeriod` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pPeriod` - Time between to scheduled calls (after the initial call) in Milliseconds. This value must be bigger than 0.
  Throws:
    `java.security.InvalidParameterException` - If the given value is less or equal than 0

### getInitialStartDate

    public java.lang.String getInitialStartDate()

  Specified by:
    `getInitialStartDate` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Date (and time) of the first scheduled. For value see `setInitialStartDate()` method.

### setInitialStartDate

    public void setInitialStartDate(java.lang.String pStartDate)

  Description copied from interface: `SchedulerMBean`
  Sets the first scheduled call. If the date is in the past the scheduler tries to find the next available start date.
  Specified by:
    `setInitialStartDate` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pStartDate` - Date when the initial call is scheduled. It can be either:
    - NOW: date will be the current date (new Date()) plus 1 seconds
    - Date as String able to be parsed by SimpleDateFormat with default format
    - Milliseconds since 1/1/1970
    If the date is in the past the Scheduler will search a start date in the future with respect to the initial repe- titions and the period between calls. This means that when you restart the MBean (restarting JBoss etc.) it will start at the next scheduled time. When no start date is available in the future the Scheduler will not start.
    Example: if you start your Schedulable everyday at Noon and you restart your JBoss server then it will start at the next Noon (the same if started before Noon or the next day if start after Noon).

### getInitialRepetitions

    public long getInitialRepetitions()

  Specified by:
    `getInitialRepetitions` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Number of scheduled calls initially. If -1 then there is not limit.

### setInitialRepetitions

    public void setInitialRepetitions(long pNumberOfCalls)

  Description copied from interface: `SchedulerMBean`
  Sets the initial number of scheduled calls.
  Specified by:
    `setInitialRepetitions` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pNumberOfCalls` - Initial Number of scheduled calls. If -1 then the number is unlimted.
  Throws:
    `java.security.InvalidParameterException` - If the given value is less or equal than 0

### getRemainingRepetitions

    public long getRemainingRepetitions()

  Specified by:
    `getRemainingRepetitions` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    Number of remaining repetitions. If -1 then there is no limit.

### isStarted

    public boolean isStarted()

  Specified by:
    `isStarted` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    True if the schedule is up and running. If you want to start the schedule with another values by using {@ #startSchedule} you have to stop the schedule first with {@ #stopSchedule} and wait until this method returns false.

### isRestartPending

    public boolean isRestartPending()

  Specified by:
    `isRestartPending` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    True if any attributes are changed but the Schedule is not restarted yet.

### isStartAtStartup

    public boolean isStartAtStartup()

  Specified by:
    `isStartAtStartup` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    True if the Schedule when the Scheduler is started

### setStartAtStartup

    public void setStartAtStartup(boolean pStartAtStartup)

  Description copied from interface: `SchedulerMBean`
  Set the scheduler to start when MBean started or not. Note that this method only affects when the `startService()` gets called (normally at startup time.
  Specified by:
    `setStartAtStartup` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Parameters:
    `pStartAtStartup` - True if Schedule has to be started at startup time

### isActive

    public boolean isActive()

  Specified by:
    `isActive` in interface `SchedulerMBean`
  Following copied from interface: `org.jboss.util.SchedulerMBean`
  Returns:
    True if this Scheduler is active and will send notifications in the future

### getObjectName

    public javax.management.ObjectName getObjectName(javax.management.MBeanServer pServer,
                                                     javax.management.ObjectName pName)
                                              throws javax.management.MalformedObjectNameException

  Overrides:
    `getObjectName` in class `ServiceMBeanSupport`

### getName

    public java.lang.String getName()

  Specified by:
    `getName` in interface `ServiceMBean`
  Overrides:
    `getName` in class `ServiceMBeanSupport`

### getServiceName

    public javax.management.ObjectName getServiceName()

### startService

    protected void startService()
                         throws java.lang.Exception

  Overrides:
    `startService` in class `ServiceMBeanSupport`

### stopService

    protected void stopService()

  Overrides:
    `stopService` in class `ServiceMBeanSupport`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000 The JBoss Organization. All Rights Reserved.